import { RuleIndex, RuleIndexOptions, RuleIndexOptionsOf, Public, RawRuleOf } from './RuleIndex';
import { Abilities, AbilityTuple, CanParameters } from './types';
import { Rule } from './Rule';
export declare type AbilityOptions<A extends Abilities, Conditions> = RuleIndexOptions<A, Conditions>;
export declare type AnyAbility = Public<PureAbility<any, any>>;
export declare type AbilityOptionsOf<T extends AnyAbility> = RuleIndexOptionsOf<T>;
export declare type AbilityClass<T extends AnyAbility> = new (rules: RawRuleOf<T>[], options: AbilityOptionsOf<T>) => T;
export declare class PureAbility<A extends Abilities = AbilityTuple, Conditions = unknown> extends RuleIndex<A, Conditions> {
    can(...args: CanParameters<A>): boolean;
    relevantRuleFor(...args: CanParameters<A>): Rule<A, Conditions> | null;
    cannot(...args: CanParameters<A>): boolean;
}
